Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1959)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Separate humidity and passive scalar
 ! 
 ! Former revisions:
@@ -192,12 +192,13 @@
     USE arrays_3d,                                                             &
         ONLY:  diss_l_e, diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr,            &
-               diss_l_sa, diss_s_e, diss_s_nr, diss_s_pt, diss_s_q,            &
-               diss_s_qr, diss_s_sa, e, e_p, flux_s_e, flux_s_nr, flux_s_pt,   &
-               flux_s_q, flux_s_qr, flux_s_sa, flux_l_e, flux_l_nr,            &
-               flux_l_pt, flux_l_q, flux_l_qr, flux_l_sa, nr, nr_p, nrsws,     &
-               nrswst, pt, ptdf_x, ptdf_y, pt_init, pt_p, prho, q, q_init,     &
-               q_p, qsws, qswst, qr, qr_p, qrsws, qrswst, rdf, rdf_sc,         &
-               ref_state, rho, sa, sa_init, sa_p, saswsb, saswst, shf, tend,   &
-               te_m, tnr_m, tpt_m, tq_m, tqr_m, tsa_m, tswst, tu_m, tv_m,      &
+               diss_l_s, diss_l_sa, diss_s_e, diss_s_nr, diss_s_pt, diss_s_q,  &
+               diss_s_qr, diss_s_s, diss_s_sa, e, e_p, flux_s_e, flux_s_nr,    &
+               flux_s_pt, flux_s_q, flux_s_qr, flux_s_s, flux_s_sa, flux_l_e,  &
+               flux_l_nr, flux_l_pt, flux_l_q, flux_l_qr, flux_l_s, flux_l_sa, &
+               nr, nr_p, nrsws, nrswst, pt, ptdf_x, ptdf_y, pt_init, pt_p,     &
+               prho, q, q_init, q_p, qsws, qswst, qr, qr_p, qrsws, qrswst, rdf,&
+               rdf_sc, ref_state, rho, s, s_init, s_p, sa, sa_init, sa_p,      &
+               saswsb, saswst, shf, ssws, sswst, tend,                         &
+               te_m, tnr_m, tpt_m, tq_m, tqr_m, ts_m, tsa_m, tswst, tu_m, tv_m,&
                tw_m, u, ug, u_init, u_p, v, vg, vpt, v_init, v_p, w, w_p
         
@@ -216,5 +217,5 @@
                use_upstream_for_tke, wall_heatflux,                            &
                wall_nrflux, wall_qflux, wall_qflux, wall_qflux, wall_qrflux,   &
-               wall_salinityflux, ws_scheme_mom, ws_scheme_sca
+               wall_salinityflux, wall_sflux, ws_scheme_mom, ws_scheme_sca
 
     USE cpulog,                                                                &
@@ -724,7 +725,6 @@
 
 !
-!--       If required, compute prognostic equation for total water content /
-!--       scalar
-          IF ( humidity  .OR.  passive_scalar )  THEN
+!--       If required, compute prognostic equation for total water content
+          IF ( humidity )  THEN
 
 !
@@ -745,5 +745,5 @@
 
 !
-!--          Sink or source of scalar concentration due to canopy elements
+!--          Sink or source of humidity due to canopy elements
              IF ( plant_canopy )  CALL pcm_tendency( i, j, 5 )
 
@@ -881,5 +881,78 @@
 
           ENDIF
-
+          
+!
+!--       If required, compute prognostic equation for scalar
+          IF ( passive_scalar )  THEN
+!
+!--          Tendency-terms for total water content / scalar
+             tend(:,j,i) = 0.0_wp
+             IF ( timestep_scheme(1:5) == 'runge' ) &
+             THEN
+                IF ( ws_scheme_sca )  THEN
+                   CALL advec_s_ws( i, j, s, 's', flux_s_s, & 
+                                diss_s_s, flux_l_s, diss_l_s, i_omp_start, tn )
+                ELSE 
+                   CALL advec_s_pw( i, j, s )
+                ENDIF
+             ELSE
+                CALL advec_s_up( i, j, s )
+             ENDIF
+             CALL diffusion_s( i, j, s, ssws, sswst, wall_sflux )
+
+!
+!--          Sink or source of scalar concentration due to canopy elements
+             IF ( plant_canopy )  CALL pcm_tendency( i, j, 7 )
+
+!
+!--          Large scale advection, still need to be extended for scalars
+!              IF ( large_scale_forcing )  THEN
+!                 CALL ls_advec( i, j, simulated_time, 's' )
+!              ENDIF
+
+!
+!--          Nudging, still need to be extended for scalars
+!              IF ( nudging )  CALL nudge( i, j, simulated_time, 's' ) 
+
+!
+!--          If required compute influence of large-scale subsidence/ascent.
+!--          Note, the last argument is of no meaning in this case, as it is 
+!--          only used in conjunction with large_scale_forcing, which is to 
+!--          date not implemented for scalars.
+             IF ( large_scale_subsidence  .AND.                                &
+                  .NOT. use_subsidence_tendencies  .AND.                       &
+                  .NOT. large_scale_forcing )  THEN
+                CALL subsidence( i, j, tend, s, s_init, 3 )
+             ENDIF
+
+             CALL user_actions( i, j, 's-tendency' )
+
+!
+!--          Prognostic equation for scalar
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                s_p(k,j,i) = s(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * ts_m(k,j,i) )       &
+                                      - tsc(5) * rdf_sc(k) *                   &
+                                        ( s(k,j,i) - s_init(k) )
+                IF ( s_p(k,j,i) < 0.0_wp )  s_p(k,j,i) = 0.1_wp * s(k,j,i)
+             ENDDO
+
+!
+!--          Calculate tendencies for the next Runge-Kutta step
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( intermediate_timestep_count == 1 )  THEN
+                   DO  k = nzb_s_inner(j,i)+1, nzt
+                      ts_m(k,j,i) = tend(k,j,i)
+                   ENDDO
+                ELSEIF ( intermediate_timestep_count < &
+                         intermediate_timestep_count_max )  THEN
+                   DO  k = nzb_s_inner(j,i)+1, nzt
+                      ts_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
+                                     5.3125_wp * ts_m(k,j,i)
+                   ENDDO
+                ENDIF
+             ENDIF
+
+          ENDIF          
 !
 !--       If required, compute prognostic equation for turbulent kinetic 
@@ -1432,8 +1505,8 @@
 
 !
-!-- If required, compute prognostic equation for total water content / scalar
-    IF ( humidity  .OR.  passive_scalar )  THEN
-
-       CALL cpu_log( log_point(29), 'q/s-equation', 'start' )
+!-- If required, compute prognostic equation for total water content
+    IF ( humidity )  THEN
+
+       CALL cpu_log( log_point(29), 'q-equation', 'start' )
 
 !
@@ -1470,5 +1543,5 @@
        
 !
-!--    Sink or source of scalar concentration due to canopy elements
+!--    Sink or source of humidity due to canopy elements
        IF ( plant_canopy ) CALL pcm_tendency( 5 )
 
@@ -1493,5 +1566,5 @@
 
 !
-!--    Prognostic equation for total water content / scalar
+!--    Prognostic equation for total water content
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -1529,5 +1602,5 @@
        ENDIF
 
-       CALL cpu_log( log_point(29), 'q/s-equation', 'stop' )
+       CALL cpu_log( log_point(29), 'q-equation', 'stop' )
 
 !
@@ -1686,5 +1759,107 @@
 
     ENDIF
-
+!
+!-- If required, compute prognostic equation for scalar
+    IF ( passive_scalar )  THEN
+
+       CALL cpu_log( log_point(66), 's-equation', 'start' )
+
+!
+!--    Scalar/q-tendency terms with communication
+       sbt = tsc(2)
+       IF ( scalar_advec == 'bc-scheme' )  THEN
+
+          IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
+             sbt = 1.0_wp
+          ENDIF
+          tend = 0.0_wp
+          CALL advec_s_bc( s, 's' )
+
+       ENDIF
+
+!
+!--    Scalar/q-tendency terms with no communication
+       IF ( scalar_advec /= 'bc-scheme' )  THEN
+          tend = 0.0_wp
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( ws_scheme_sca )  THEN
+                CALL advec_s_ws( s, 's' )
+             ELSE
+                CALL advec_s_pw( s )
+             ENDIF
+          ELSE
+             CALL advec_s_up( s )
+          ENDIF
+       ENDIF
+
+       CALL diffusion_s( s, ssws, sswst, wall_sflux )
+       
+!
+!--    Sink or source of humidity due to canopy elements
+       IF ( plant_canopy ) CALL pcm_tendency( 7 )
+
+!
+!--    Large scale advection. Not implemented for scalars so far.
+!        IF ( large_scale_forcing )  THEN
+!           CALL ls_advec( simulated_time, 'q' )
+!        ENDIF
+
+!
+!--    Nudging. Not implemented for scalars so far.
+!        IF ( nudging )  CALL nudge( simulated_time, 'q' ) 
+
+!
+!--    If required compute influence of large-scale subsidence/ascent.
+!--    Not implemented for scalars so far.
+       IF ( large_scale_subsidence  .AND.                                      &
+            .NOT. use_subsidence_tendencies  .AND.                             &
+            .NOT. large_scale_forcing )  THEN
+         CALL subsidence( tend, s, s_init, 3 )
+       ENDIF
+
+       CALL user_actions( 's-tendency' )
+
+!
+!--    Prognostic equation for total water content
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                s_p(k,j,i) = s(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
+                                                  tsc(3) * ts_m(k,j,i) )       &
+                                      - tsc(5) * rdf_sc(k) *                   &
+                                        ( s(k,j,i) - s_init(k) )
+                IF ( s_p(k,j,i) < 0.0_wp )  s_p(k,j,i) = 0.1_wp * s(k,j,i)
+             ENDDO
+          ENDDO
+       ENDDO
+
+!
+!--    Calculate tendencies for the next Runge-Kutta step
+       IF ( timestep_scheme(1:5) == 'runge' )  THEN
+          IF ( intermediate_timestep_count == 1 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_s_inner(j,i)+1, nzt
+                      ts_m(k,j,i) = tend(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSEIF ( intermediate_timestep_count < &
+                   intermediate_timestep_count_max )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_s_inner(j,i)+1, nzt
+                      ts_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * ts_m(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+       ENDIF
+
+       CALL cpu_log( log_point(66), 's-equation', 'stop' )
+
+    ENDIF
 !
 !-- If required, compute prognostic equation for turbulent kinetic 
@@ -2226,8 +2401,8 @@
 
 !
-!-- If required, compute prognostic equation for total water content / scalar
-    IF ( humidity  .OR.  passive_scalar )  THEN
-
-       CALL cpu_log( log_point(29), 'q/s-equation', 'start' )
+!-- If required, compute prognostic equation for total water content
+    IF ( humidity )  THEN
+
+       CALL cpu_log( log_point(29), 'q-equation', 'start' )
 
 !
@@ -2307,5 +2482,5 @@
        ENDDO
 
-       CALL cpu_log( log_point(29), 'q/s-equation', 'stop' )
+       CALL cpu_log( log_point(29), 'q-equation', 'stop' )
 
 !
@@ -2430,4 +2605,91 @@
     ENDIF
 
+!
+!-- If required, compute prognostic equation for scalar
+    IF ( passive_scalar )  THEN
+
+       CALL cpu_log( log_point(66), 's-equation', 'start' )
+
+!
+!--    Scalar/q-tendency terms with communication
+       sbt = tsc(2)
+       IF ( scalar_advec == 'bc-scheme' )  THEN
+
+          IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
+             sbt = 1.0_wp
+          ENDIF
+          tend = 0.0_wp
+          CALL advec_s_bc( s, 's' )
+
+       ENDIF
+
+!
+!--    Scalar/q-tendency terms with no communication
+       IF ( scalar_advec /= 'bc-scheme' )  THEN
+          tend = 0.0_wp
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( ws_scheme_sca )  THEN
+                CALL advec_s_ws( s, 's' )
+             ELSE
+                CALL advec_s_pw( s )
+             ENDIF
+          ELSE
+             CALL advec_s_up( s )
+          ENDIF
+       ENDIF
+
+       CALL diffusion_s( s, ssws, sswst, wall_sflux )
+
+!
+!--    Sink or source of scalar concentration due to canopy elements
+       IF ( plant_canopy ) CALL pcm_tendency( 7 )
+
+!
+!--    Large scale advection. Not implemented so far.
+!        IF ( large_scale_forcing )  THEN
+!           CALL ls_advec( simulated_time, 's' )
+!        ENDIF
+
+!
+!--    Nudging. Not implemented so far.
+!        IF ( nudging )  CALL nudge( simulated_time, 's' ) 
+
+!
+!--    If required compute influence of large-scale subsidence/ascent.
+!--    Not implemented so far.
+       IF ( large_scale_subsidence  .AND.                                      &
+            .NOT. use_subsidence_tendencies  .AND.                             &
+            .NOT. large_scale_forcing )  THEN
+         CALL subsidence( tend, s, s_init, 3 )
+       ENDIF
+
+       CALL user_actions( 's-tendency' )
+
+!
+!--    Prognostic equation for total water content / scalar
+       DO  i = i_left, i_right
+          DO  j = j_south, j_north
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                s_p(k,j,i) = s(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
+                                                  tsc(3) * ts_m(k,j,i) )       &
+                                      - tsc(5) * rdf_sc(k) *                   &
+                                        ( s(k,j,i) - s_init(k) )
+                IF ( s_p(k,j,i) < 0.0_wp )  s_p(k,j,i) = 0.1_wp * s(k,j,i)
+!
+!--             Tendencies for the next Runge-Kutta step
+                IF ( runge_step == 1 )  THEN
+                   ts_m(k,j,i) = tend(k,j,i)
+                ELSEIF ( runge_step == 2 )  THEN
+                   ts_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * ts_m(k,j,i)
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point(66), 's-equation', 'stop' )
+
+    ENDIF
 !
 !-- If required, compute prognostic equation for turbulent kinetic
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 1959)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 1960)
@@ -107,8 +107,8 @@
         ONLY:  e, kh, km, ol, p, pt, q, ql, qc, nr, nrs, nrsws, nrswst,        &
                prr, precipitation_amount, qr,                                  &
-               qrs, qrsws, qrswst, qs, qsws, qswst, sa, saswsb, saswst,        &
-               rif_wall, shf, ts, tswst, u, u_m_l, u_m_n, u_m_r, u_m_s, us,    &
-               usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, vsws, vswst,   &
-               w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h, z0q
+               qrs, qrsws, qrswst, qs, qsws, qswst, s, sa, saswsb, saswst,     &
+               ss, ssws, sswst, rif_wall, shf, ss, ts, tswst, u, u_m_l, u_m_n, &
+               u_m_r, u_m_s, us, usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s,   &
+               vpt, vsws, vswst, w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h, z0q
 
     USE averaging
@@ -985,4 +985,9 @@
                    rif_wall(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp,:) = &
                             tmp_4d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp,:)
+                            
+                CASE ( 's' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   s(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                    tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 's_av' )
@@ -1067,5 +1072,28 @@
                       ENDIF
                    ENDIF
-
+                   
+                CASE ( 'ss' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   ss(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'ssws' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   ssws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'ssws_av' )
+                   IF ( .NOT. ALLOCATED( ssws_av ) )  THEN
+                      ALLOCATE( ssws_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   ssws_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'sswst' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   sswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp) 
+                 
                 CASE ( 'ts' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 1959)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 1960)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Separate humidity and passive scalar
+! Remove unused variables from ONLY list
 !
 ! Former revisions:
@@ -175,5 +176,5 @@
     USE arrays_3d,                                                             &
         ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,           &
-               q_init, ref_state, sa_init, u_init, ug, v_init, vg
+               q_init, ref_state, s_init, sa_init, u_init, ug, v_init, vg
 
     USE control_parameters
@@ -292,5 +293,5 @@
        ALLOCATE( ug(0:nz+1), u_init(0:nz+1), vg(0:nz+1),                       &
                  v_init(0:nz+1), pt_init(0:nz+1), q_init(0:nz+1),              &
-                 ref_state(0:nz+1), sa_init(0:nz+1),                           &
+                 ref_state(0:nz+1), s_init(0:nz+1), sa_init(0:nz+1),           &
                  hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions),        &
                  hom_sum(0:nz+1,pr_palm+max_pr_user,0:statistic_regions) )
@@ -486,5 +487,5 @@
           CASE ( 'mean_inflow_profiles' )
              IF ( .NOT. ALLOCATED( mean_inflow_profiles ) )  THEN
-                ALLOCATE( mean_inflow_profiles(0:nz+1,6) )
+                ALLOCATE( mean_inflow_profiles(0:nz+1,7) )
              ENDIF
              READ ( 13 )  mean_inflow_profiles
@@ -597,4 +598,16 @@
           CASE ( 'run_coupled' )
              READ ( 13 )  run_coupled
+          CASE ( 's_init' )
+             READ ( 13 )  s_init
+          CASE ( 's_surface' )
+             READ ( 13 )  s_surface
+          CASE ( 's_surface_initial_change' )
+             READ ( 13 )  s_surface_initial_change
+          CASE ( 's_vertical_gradient' )
+             READ ( 13 )  s_vertical_gradient
+          CASE ( 's_vertical_gradient_level' )
+             READ ( 13 )  s_vertical_gradient_level
+          CASE ( 's_vertical_gradient_level_ind' )
+             READ ( 13 )  s_vertical_gradient_level_ind 
           CASE ( 'sa_init' )
              READ ( 13 )  sa_init
@@ -617,12 +630,4 @@
           CASE ( 'surface_waterflux' )
              READ ( 13 )  surface_waterflux      
-          CASE ( 's_surface' )
-             READ ( 13 )  s_surface
-          CASE ( 's_surface_initial_change' )
-             READ ( 13 )  s_surface_initial_change
-          CASE ( 's_vertical_gradient' )
-             READ ( 13 )  s_vertical_gradient
-          CASE ( 's_vertical_gradient_level' )
-             READ ( 13 )  s_vertical_gradient_level
           CASE ( 'time_coupling' )
              READ ( 13 )  time_coupling
@@ -789,6 +794,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,           &
-               q_init, ref_state, sa_init, u_init, ug, v_init, vg
+        ONLY:  inflow_damping_factor, mean_inflow_profiles, ref_state, ug, vg
 
     USE control_parameters
Index: palm/trunk/SOURCE/spectra_mod.f90
===================================================================
--- palm/trunk/SOURCE/spectra_mod.f90	(revision 1959)
+++ palm/trunk/SOURCE/spectra_mod.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Additional default spectra for passive scalar
 ! 
 ! Former revisions:
@@ -480,5 +480,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  d, pt, q, u, v, w
+           ONLY:  d, pt, q, s, u, v, w
 
        USE indices,                                                            &
@@ -532,4 +532,8 @@
           pr = 41
           d(nzb+1:nzt,nys:nyn,nxl:nxr) = q(nzb+1:nzt,nys:nyn,nxl:nxr)
+          
+       CASE ( 's' )
+          pr = 117
+          d(nzb+1:nzt,nys:nyn,nxl:nxr) = s(nzb+1:nzt,nys:nyn,nxl:nxr)
        
        CASE DEFAULT
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1959)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Scalar surface flux added
 ! 
 ! Former revisions:
@@ -101,5 +101,6 @@
     USE arrays_3d,                                                             &
         ONLY:  dzw, e, nr, ol, p, pt, precipitation_rate, q, qc, ql, ql_c,     &
-               ql_v, qr, qsws, rho, sa, shf, ts, u, us, v, vpt, w, z0, z0h, z0q
+               ql_v, qr, qsws, rho, sa, shf, ssws, ts, u, us, v, vpt, w, z0,   &
+               z0h, z0q
 
     USE averaging,                                                             &
@@ -107,6 +108,6 @@
                precipitation_rate_av, pt_av, q_av, qc_av, ql_av, ql_c_av,      &
                ql_v_av, ql_vp_av, qr_av, qsws_av, qv_av, rho_av, s_av, sa_av,  &
-               shf_av, ts_av, u_av, us_av, v_av, vpt_av, w_av, z0_av, z0h_av,  &
-               z0q_av
+               shf_av, ssws_av, ts_av, u_av, us_av, v_av, vpt_av, w_av, z0_av, &
+               z0h_av, z0q_av
 
     USE cloud_parameters,                                                      &
@@ -949,4 +950,11 @@
              ENDDO
 
+          CASE ( 'ssws*' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   ssws_av(j,i) = ssws_av(j,i) + ssws(j,i)
+                ENDDO
+             ENDDO
+
           CASE ( 't*' )
              DO  i = nxlg, nxrg
Index: palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 1959)
+++ palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-!  
+! Treat humidity and passive scalar separately
 ! 
 ! Former revisions:
@@ -141,5 +141,6 @@
     USE arrays_3d,                                                             &
         ONLY:  e, kh, nr, nrs, nrsws, ol, pt, q, ql, qr, qrs, qrsws, qs, qsws, &
-               shf, ts, u, us, usws, v, vpt, vsws, zu, zw, z0, z0h, z0q
+               s, shf, ss, ssws, ts, u, us, usws, v, vpt, vsws, zu, zw, z0,    &
+               z0h, z0q
 
     USE cloud_parameters,                                                      &
@@ -152,7 +153,8 @@
 
     USE control_parameters,                                                    &
-        ONLY:  cloud_physics, constant_heatflux, constant_waterflux,           &
-               coupling_mode, g, humidity, ibc_e_b, ibc_pt_b,                  &
-               initializing_actions, kappa, intermediate_timestep_count,       &
+        ONLY:  cloud_physics, constant_heatflux, constant_scalarflux,          &
+               constant_waterflux, coupling_mode, g, humidity, ibc_e_b,        &
+               ibc_pt_b, initializing_actions, kappa,                          &
+               intermediate_timestep_count,                                    &
                intermediate_timestep_count_max, large_scale_forcing, lsf_surf, &
                message_string, microphysics_seifert, most_method, neutral,     &
@@ -859,5 +861,5 @@
 !
 !--    If required compute q*
-       IF ( humidity  .OR.  passive_scalar )  THEN
+       IF ( humidity )  THEN
           IF ( constant_waterflux )  THEN
 !
@@ -922,4 +924,20 @@
           ENDIF
        ENDIF
+       
+!
+!--    If required compute s*
+       IF ( passive_scalar )  THEN
+          IF ( constant_scalarflux )  THEN
+!
+!--          For a given water flux in the surface layer
+             !$OMP PARALLEL DO
+             !$acc kernels loop private( j )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   ss(j,i) = -ssws(j,i) / ( us(j,i) + 1E-30_wp )
+                ENDDO
+             ENDDO
+          ENDIF
+       ENDIF
 
 
@@ -1043,7 +1061,7 @@
 
 !
-!-- Compute the vertical water/scalar flux
-       IF (  .NOT.  constant_waterflux  .AND.  ( humidity  .OR.                &
-             passive_scalar )  .AND.  ( simulated_time <= skip_time_do_lsm     &
+!--    Compute the vertical water flux
+       IF (  .NOT.  constant_waterflux  .AND.  humidity  .AND.                 &
+             ( simulated_time <= skip_time_do_lsm                              &
             .OR.  .NOT.  land_surface ) )  THEN
           !$OMP PARALLEL DO
@@ -1057,4 +1075,20 @@
 
        ENDIF
+       
+!
+!--    Compute the vertical scalar flux
+       IF (  .NOT.  constant_scalarflux  .AND.  passive_scalar  .AND.          &
+             ( simulated_time <= skip_time_do_lsm                              &
+            .OR.  .NOT.  land_surface ) )  THEN
+          !$OMP PARALLEL DO
+          !$acc kernels loop independent present( qs, qsws, us )
+          DO  i = nxlg, nxrg
+             !$acc loop independent
+             DO  j = nysg, nyng
+                ssws(j,i) = -ss(j,i) * us(j,i)
+             ENDDO
+          ENDDO
+
+       ENDIF       
 
 !
Index: palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- palm/trunk/SOURCE/swap_timelevel.f90	(revision 1959)
+++ palm/trunk/SOURCE/swap_timelevel.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Separate humidity and passive scalar
 !
 ! Former revisions:
@@ -83,11 +83,11 @@
 #if defined( __nopointer )
     USE arrays_3d,                                                             &
-        ONLY:  e, e_p, nr, nr_p, pt, pt_p, q, q_p, qr, qr_p, sa, sa_p, u, u_p, &
-               v, v_p, w, w_p
+        ONLY:  e, e_p, nr, nr_p, pt, pt_p, q, q_p, qr, qr_p, s, s_p, sa, sa_p, &
+               u, u_p, v, v_p, w, w_p
 #else
     USE arrays_3d,                                                             &
         ONLY:  e, e_1, e_2, e_p, nr, nr_1, nr_2, nr_p, pt, pt_1, pt_2, pt_p, q,&
-               q_1, q_2, q_p, qr, qr_1, qr_2, qr_p, sa, sa_1, sa_2, sa_p, u,   &
-               u_1, u_2, u_p, v, v_1, v_2, v_p, w, w_1, w_2, w_p
+               q_1, q_2, q_p, qr, qr_1, qr_2, qr_p, s, s_1, s_2, s_p, sa, sa_1,&
+               sa_2, sa_p, u, u_1, u_2, u_p, v, v_1, v_2, v_p, w, w_1, w_2, w_p
 
 #endif
@@ -162,5 +162,5 @@
        sa = sa_p
     ENDIF
-    IF ( humidity  .OR.  passive_scalar )  THEN
+    IF ( humidity )  THEN
        q = q_p             
        IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -169,4 +169,5 @@
        ENDIF
     ENDIF
+    IF ( passive_scalar )  s = s_p             
 
     IF ( land_surface )  THEN
@@ -195,5 +196,5 @@
              sa => sa_1;  sa_p => sa_2
           ENDIF
-          IF ( humidity  .OR.  passive_scalar )  THEN
+          IF ( humidity )  THEN
              q => q_1;    q_p => q_2
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -202,4 +203,7 @@
              ENDIF
           ENDIF
+          IF ( passive_scalar )  THEN
+             s => s_1;    s_p => s_2
+          ENDIF
 
           IF ( land_surface )  THEN
@@ -223,5 +227,5 @@
              sa => sa_2;  sa_p => sa_1
           ENDIF
-          IF ( humidity  .OR.  passive_scalar )  THEN
+          IF ( humidity )  THEN
              q => q_2;    q_p => q_1
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
@@ -230,4 +234,7 @@
              ENDIF
           ENDIF
+          IF ( passive_scalar )  THEN
+             s => s_2;    s_p => s_1
+          ENDIF
 
           IF ( land_surface )  THEN
